﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using InterLinq.Base;
using InterLinq.Services.Interfaces;
using Sebarf.Services.Interfaces;

#endregion

namespace Sebastof.Server.Services.Impl {
	/// <summary>
	/// Description of the class
	/// </summary>
	public class BackendProviderService : Service, IBackendProviderLocatorService, IBackendProviderRegisterService {
		#region Public Properties

		public IBackendProvider BackendProvider { get; private set; }

		#endregion

		#region IBackendProviderLocatorService Members

		public IBackendProvider GetBackendProvider() {
			return BackendProvider;
		}

		#endregion

		#region IBackendProviderRegisterService Members

		public void SetBackendProvider(IBackendProvider provider) {
			BackendProvider = provider;
		}

		#endregion
	}
}