﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System.Linq;
using InterLinq.Client;

#endregion

namespace InterLinq.Test.DH {
	/// <summary>
	/// Description of the class
	/// </summary>
	public class LinqToSQLDataContext : ClientContext {
		#region Public Properties

		/// <summary>
		/// Get all available orders
		/// </summary>
		public IQueryable<SQL.Order> Orders {
			get { return QueryHandler.GetTable<SQL.Order>(); }
		}

		public IQueryable<SQL.Product> Products {
			get { return QueryHandler.GetTable<SQL.Product>(); }
		}

		#endregion

		#region Public Methods

		/// <summary>
		/// Ctr
		/// </summary>
		/// <param name="queryHandler"></param>
		public LinqToSQLDataContext(IQueryHandler queryHandler) {
			QueryHandler = queryHandler;
		}

		#endregion
	}
}