﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;

#endregion

namespace InterLinq.Test {
	/// <summary>
	/// Description of the class
	/// </summary>
	[Serializable]
	internal class Product : IProduct {
		#region Public Properties

		/// <summary>
		/// Returns the name of the product
		/// </summary>
		public string Name { get; set; }

		/// <summary>
		/// Gets or sets the id of the product
		/// </summary>
		public Guid Id { get; set; }

		/// <summary>
		/// Returns the price of the product in sfr
		/// </summary>
		public decimal Price { get; private set; }

		#endregion

		#region Public Methods

		/// <summary>
		/// Ctr
		/// </summary>
		/// <param name="name">name of the product</param>
		/// <param name="price">price of the product [sfr]</param>
		public Product(string name, decimal price) {
			Name = name;
			Price = price;
			Id = Guid.NewGuid();
		}

		#endregion

		#region Private Methods

		// private methods located here

		#endregion

		#region Private Fields

		// private fields located here

		#endregion
	}
}