﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;

#endregion

namespace InterLinq.Test.Views {
	/// <summary>
	/// Defines a order that does calculate the count of order based on a function
	/// </summary>
	internal class OrderPositionsByOrderLinqFunqView : IOrderPositionsByOrderStupidSimpleView {
		#region Public Methods

		public OrderPositionsByOrderLinqFunqView(IOrder order, Func<IOrder, int> calculateCountMethod) {
			m_order = order;
			m_calculateCountMethod = calculateCountMethod;
		}

		#endregion

		#region Private Fields

		private readonly Func<IOrder, int> m_calculateCountMethod;
		private readonly IOrder m_order;

		#endregion

		#region IOrderPositionsByOrderStupidSimpleView Members

		public string OrderName {
			get { return m_order.Name; }
			set { m_order.Name = value; }
		}

		public int ComputedNumber {
			get { return m_calculateCountMethod(m_order); }
		}

		#endregion
	}
}