﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using Sebarf.Core.Interfaces;
using Sebarf.Services.Interfaces;

#endregion

namespace Sebarf.Core.Internal {
	/// <summary>
	/// Description of the class
	/// </summary>
	public class RequestRemoteHandlerEngineLocatorService : Service, IRequestRemoteHandlerEngineLocatorService {
		#region Public Properties

		public IRequestHandlerEngine RequestHandlerEngine { get; set; }

		#endregion

		#region Public Methods

		public RequestRemoteHandlerEngineLocatorService(IRequestHandlerEngine engine) {
			RequestHandlerEngine = engine;
		}

		public RequestRemoteHandlerEngineLocatorService() {
		}

		#endregion

		#region IRequestRemoteHandlerEngineLocatorService Members

		public IRequestHandlerEngine GetRemoteEngine() {
			return RequestHandlerEngine;
		}

		public void SetRemoteEngine(IRequestHandlerEngine engine) {
			RequestHandlerEngine = engine;
		}

		#endregion
	}
}