﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;
using System.Collections.Generic;

#endregion

namespace Sebarf.Profiles.WPF {
	/// <summary>
	/// Description of the class
	/// </summary>
	[Serializable]
	public class WpfBasedProfileLoadRequest : ProfileLoadRequest {
		public const string XAMLFILEPATHARGNAME = "ResourceFileName";

		public string ResourceFileName {
			get { return ProfileLoadArguments[XAMLFILEPATHARGNAME].ToString(); }
			set { ProfileLoadArguments[XAMLFILEPATHARGNAME] = value; }
		}

		#region Public Methods

		public WpfBasedProfileLoadRequest() {
			ProfileLoadArguments = new Dictionary<string, object>();
			ProfileLoadArguments.Add(XAMLFILEPATHARGNAME, "");
		}

		public WpfBasedProfileLoadRequest(string profileId, string xamlFilePath) {
			ProfileLoadArguments = new Dictionary<string, object>();
			ProfileId = profileId;
			ProfileLoadArguments.Add(XAMLFILEPATHARGNAME, xamlFilePath);
		}

		#endregion
	}
}