﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;
using System.Collections.Generic;
using Sebarf.Core.Interfaces;

#endregion

namespace Sebarf.Security.Interfaces {
	/// <summary>
	/// Generic authentication request
	/// </summary>
	[Serializable]
	public class DoAuthenticationRequest : IRequest {
		#region Public Properties

		public IDictionary<String, Object> AuthenticationArguments { get; set; }

		#endregion

		#region Public Methods

		public DoAuthenticationRequest(params KeyValuePair<string, Object>[] args) {
			AuthenticationArguments = new Dictionary<string, object>();
			foreach (var entry in args) {
				AuthenticationArguments.Add(entry.Key, entry.Value);
			}
		}

		#endregion
	}
}