﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System.Collections.Generic;

#endregion

namespace Sebarf.Security.Interfaces {
	/// <summary>
	/// Is responsible for determination 
	/// if an access is allowed whereas an access 
	/// is defined by the name of the action 
	/// and multiple additional named parameters.
	/// </summary>
	public interface IAuthorizationService {
		#region Public Methods

		/// <summary>
		/// checks if the given access is allowed whereas an access 
		/// is defined by the name of the action 
		/// and multiple additional named parameters.
		/// </summary>
		/// <param name="action"></param>
		/// <param name="args"></param>
		/// <returns></returns>
		bool CheckAccess(string action, Dictionary<string, object> args);

		#endregion
	}
}