﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using Sebarf.Core.Interfaces;

#endregion

namespace Sebarf.Server {
	/// <summary>
	/// Is responsible for:
	/// - a. representing a Sebarf based server instance
	/// - b. on which Sebarf client could connect
	/// - c. accept client request, process them and return the response
	/// </summary>
	public interface IServer : IRemoteRequestHandlerEngine {
		#region Public Methods

		/// <summary>
		/// starts the server
		/// </summary>
		void Start();

		/// <summary>
		/// stops the server
		/// </summary>
		void Stop();

		#endregion
	}
}