﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System.Collections.Generic;

#endregion

namespace Sebarf.Services.Interfaces {
	/// <summary>
	/// The monitoring data collector serices interface.
	/// </summary>
	public interface IDiagnosticsDataCollectorService {
		#region Public Methods

		/// <summary>
		/// returns the collected data. The key of the KeyValuePair contains a string composed out of the
		/// name of the service + name of the serie.
		/// </summary>
		/// <returns></returns>
		KeyValuePair<string, List<ExtendedServiceStatisticEntry>>[] GetCollectedDiagnosticsDataOverTime();

		#endregion
	}

	public class ExtendedServiceStatisticEntry {
		public ServiceStatistics ServiceStatistics { get; set; }
		public ServiceStatisticEntry ServiceStatisticEntry { get; set; }
	}
}