﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using Sebarf.Core.Interfaces;

#endregion

namespace Sebarf.Session.Interfaces {
	/// <summary>
	/// Is responsible for forwarding the close session request to a IUserSessionHandlerService
	/// </summary>
	public class CloseSessionRequestHandler : RequestHandler<CloseSessionRequest> {
		#region Public Methods

		protected override object OnProcessRequest(CloseSessionRequest request, IServiceLocatorService serviceLocator) {
			serviceLocator.GetRegisteredService<IUserSessionHandlerService>().RemoveSession();
			return true;
		}

		#endregion
	}
}