﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using Sebarf.Core.Interfaces;

#endregion

namespace Sebarf.Session.Interfaces {
	/// <summary>
	/// Is responsible for forwaring a ResetSessionTimeoutRequest to a ISessionTimeoutHandlerService
	/// </summary>
	public class ResetSessionTimeoutRequestHandler : RequestHandler<ResetSessionTimeoutRequest> {
		#region Public Methods

		protected override object OnProcessRequest(ResetSessionTimeoutRequest request, IServiceLocatorService serviceLocator) {
			serviceLocator.GetRegisteredService<ISessionTimeoutHandlerService>().ResetTimeout();
			return true;
		}

		#endregion
	}
}