﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;
using Sebarf.Services.Interfaces;
using Sebastof.Core.Services.Interfaces;

#endregion

namespace Sebastof.Client.Services.Impl {
	/// <summary>
	/// Impl of <see cref="ISetTargetTypeService"/> and <see cref="IGetTargetTypeService"/>
	/// </summary>
	public class DeserializationTargetTypeService : Service, IDeserializationSetTargetTypeService,
													IDeserializationGetTargetTypeService {
		#region Public Properties

		public Type TargetType { get; set; }

		#endregion

		#region IDeserializationGetTargetTypeService Members

		public Type GetTargetType() {
			return TargetType;
		}

		#endregion

		#region IDeserializationSetTargetTypeService Members

		public void SetTargetType(Type targetType) {
			TargetType = targetType;
		}

		#endregion
	}
}