﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System.Collections;
using InterLinq.Types;
using Sebarf.Core.Interfaces;
using Sebarf.Services.Interfaces;
using Sebastof.Services.Interfaces;
using Utils;

#endregion

namespace Sebastof.ProcessChains.ProcessSteps {
	/// <summary>
	/// Description of the class
	/// </summary>
	public class DecorateCollection : ProcessStepConverter<IEnumerable, CollectionTransporter> {
		#region Public Properties

		[ServiceRequest]
		public IServiceLocatorService ServiceLocatorService { get; set; }

		[ServiceRequest]
		public IObjectMappingLocatorService ObjectMappingLocatorService { get; set; }

		#endregion

		public DecorateCollection(IServiceLocatorService ctx) {
			ServiceLocatorService = ctx;
			ObjectMappingLocatorService = ctx.GetRegisteredService<IObjectMappingLocatorService>();
		}

		public DecorateCollection() {
		}

		#region Public Methods

		protected override CollectionTransporter Convert(IEnumerable toProcess) {
			var toReturn = new CollectionTransporter(ServiceLocatorService, toProcess);

			return toReturn;
		}

		public override bool CanProcess(IEnumerable toProcess) {
			return base.CanProcess(toProcess) && !toProcess.GetType().Name.StartsWith("<>f__AnonymousType");
		}

		#endregion
	}
}