﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;
using System.Collections.Generic;
using Sebarf.Core.Interfaces;
using Sebastof.Types;

#endregion

namespace Sebastof.Services.Interfaces {
	/// <summary>
	/// Request for submitting changes.
	/// Client creates this request to submit the changes to the server.
	/// </summary>
	[Serializable]
	public class SubmitChangesRequest : IRequest {
		#region Public Properties

		public IEnumerable<ChangeSet> GeneralChanges { get; set; }
		public IEnumerable<ChangeCollectionSet> ChangesOnCollection { get; set; }
		public IEnumerable<NewObjectSet> ChangesByCreationOfObjects { get; set; }
		public IEnumerable<DeleteObjectSet> ChangesByDeletionOfObjects { get; set; }

		#endregion
	}
}