﻿#region Header

/*
Remote views based on linq
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

#endregion

namespace Utils {
	/// <summary>
	/// Identifies an object. At different places an object needs to be identifiable.
	/// If the object implements this interface this id will be taken. If the object
	/// does not implement this interface, the framework will generate an id for the
	/// object. Using this interface is much more performant.
	/// As an example how to generate an id, simply create a new Guid and ToString it.
	/// </summary>
	public interface IIdentifiable {
		#region Public Properties

		/// <summary>
		/// gets the id of the object
		/// </summary>
		string Id { get; set; }

		#endregion
	}
}